/*
 *	emu.c
 *
 *	Xy[XCx[_[/EMU
 *
 *	* Tue Nov 28 06:00:00 JST 2003 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

unsigned char color_table[1 << 6];

EMU g_emu;

const ROM g_rom[] = {
	{ "tv0h.s1" , 0x0000, 0x0800, 0xfef18aad },
	{ "tv02.rp1", 0x0800, 0x0800, 0x3c759a90 },
	{ "tv03.n1" , 0x1000, 0x0800, 0x0ad3657f },
	{ "tv04.m1" , 0x1800, 0x0800, 0xcd2c67f6 },
	{ NULL/*I[*/ },
};

const PATCH g_patch[] = {
	{ 0/*I[*/ },
};

/****************************************************************************
 *	
 ****************************************************************************/

void
emu_main()
{
	EMU* emu = &g_emu;
	Z80* z80 = &emu->z80;

	int skip;
	int i;

	/* ܂[NAB */
	memset(emu, 0, sizeof(EMU));

	/* ROMǂݍ݁B */
	load_rom();

	/* CPUZbgB */
	z80_reset(z80);
	//z80->read = emu_read;
	//z80->write = EMU_VXrite;
	z80->in = emu_in;
	z80->out = emu_out;

	/* ʏB */
	init_video();

	for(;;) {
		schedule();

		/* ͍XVB */
		update_input();

		for(skip = 0; skip <= EMU_SKIP; skip++) {
			/*{{Xy[XCx[_[*/
			for(i = 0; i < 2; i++) {
				z80_run(z80, CPU_CYCLE / 2);
				z80_int(z80, i & 1 ? 0xcf : 0xd7);
			}
			/*}}Xy[XCx[_[*/
		}

		/* ʍXVB */
		update_video();
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

void
load_rom()
{
	EMU* emu = &g_emu;
	unsigned char* mem = emu->mem;
	const ROM* rom = g_rom;
	const PATCH* patch = g_patch;

	int retval;
	unz_file_info ufi;

	/* ROMڑ̈̓ǂݏol-1Ɖ肵܂B */
	memset(mem, -1, 0x10000);

	/* ROMǂݍ݁B */
	while(rom->name) {
		retval = my_unzip(ROMSET_FNAME, rom->name, &mem[rom->base], rom->size, &ufi);
		if(retval != rom->size || ufi.crc != rom->crc) {
			die("ERR: %s", rom->name); /* G[bZ[WpceFontPrintf()ŗ̂Œ!! */
		}
		rom++;
	}

	/* pb`āB */
	while(patch->addr) {
		mem[patch->addr] = patch->data;
		patch++;
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

void
init_video()
{
	int i, j, n;

	/* `悵Ȃ̈NAB */
	memset(vbuff, 3, sizeof vbuff);

	/* kJ[e[u쐬B */
	for(i = 0; i <= (1 << 6) - 1; i++) {
		j = i;
		n = 0;
		while(j) {
			n += j & 1;
			j >>= 1;
		}
		color_table[i] = ((n + 1) / 2) ^ 3; /* {0,1,2,3,4,5,6}=>{3,2,2,1,1,0,0} */
	}
}

